/*#########################################################################
#                                                                         #
#   Simple script shamelessly recopied from:                              #
#                                                                         #
#   Copyright                                                             #
#                                                                         #
#   (C)  2010 Anselmo Lacerda Silveira de Melo <anselmolsm@gmail.com>     #
#   (C)  2010 Emile de Weerd <mederel+radionederland@gmail.com>           #
#   (C)  2009 MetalByte <emetalbyte@gmail.com>                            #
#   (C)  2009 Àlvar Cuevas i Fajardo <alvar@cuevas.cat>                   #
#   (C)  2008 Eirik Johansen Bjørgan  <eirikjbj@gmail.com>                #      
#   (C)  2008 Peter ZHOU <peterzhoulei@gmail.com>                         #
#   (C)  2008 Mark Kretschmann <kretschmann@kde.org>                      #
#   (C)  2007, 2008 Nikolaj Hald Nielsen  <nhnFreespirit@gmail.com>       #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         #
##########################################################################*/

Importer.loadQtBinding("qt.core");
Importer.loadQtBinding("qt.gui");

function Station( name, url, description )
{
    this.name = name;
    this.url = url;
    this.description = description;
}

categories = new Object;

categories["Bass & Jackin' House"]=new Array ( 
        new Station( "Bass & Jackin' House", "http://listen.di.fm/public1/bassnjackinhouse.pls", "Booty shaking bass-heavy House!") );
categories["Future Garage"]=new Array ( 
        new Station( "Future Garage", "http://listen.di.fm/public1/futuregarage.pls", "2step Garage with atmospheric broken beats.") );
categories["Jungle"]=new Array ( 
        new Station( "Jungle", "http://listen.di.fm/public1/jungle.pls", "The Amen Break at its finest, Jungle is massive!") );
categories["Nightcore"]=new Array ( 
        new Station( "Nightcore", "http://listen.di.fm/public1/nightcore.pls", "Pitched up vocals and Happy Hardcore beats!") );
categories["Nu Disco"]=new Array ( 
        new Station( "Nu Disco", "http://listen.di.fm/public1/nudisco.pls", "A modern twist on 70s & 80s Disco and Funk.") );
categories["Bassline"]=new Array ( 
        new Station( "Bassline", "http://listen.di.fm/public1/bassline.pls", "Vocal-driven, bass-laden speed garage!") );
categories["Oldschool House"]=new Array ( 
        new Station( "Oldschool House", "http://listen.di.fm/public1/oldschoolhouse.pls", "The sounds of old school house music!") );
categories["Oldschool Rave"]=new Array ( 
        new Station( "Oldschool Rave", "http://listen.di.fm/public1/oldschoolrave.pls", "Relive the early sounds of rave!") );
categories["Trance"]=new Array ( 
        new Station( "Trance", "http://listen.di.fm/public1/trance.pls", "The hottest, freshest trance music from around the globe!") );
categories["Vocal Trance"]=new Array ( 
        new Station( "Vocal Trance", "http://listen.di.fm/public1/vocaltrance.pls", "A fusion of trance, dance, and chilling vocals together!") );
categories["Lounge"]=new Array ( 
        new Station( "Lounge", "http://listen.di.fm/public1/lounge.pls", "Sit back and enjoy the lounge grooves!") );
categories["Chillout"]=new Array ( 
        new Station( "Chillout", "http://listen.di.fm/public1/chillout.pls", "Full of trippy flavors, this channel is just what you need to relax.") );
categories["Vocal Chillout"]=new Array ( 
        new Station( "Vocal Chillout", "http://listen.di.fm/public1/vocalchillout.pls", "Enjoy the relaxing vocal sounds of Ibiza chillout") );
categories["ChillHop"]=new Array ( 
        new Station( "ChillHop", "http://listen.di.fm/public1/chillhop.pls", "Trip Hop infused, downtempo nujazz and chillout beats.") );
categories["Chillstep"]=new Array ( 
        new Station( "Chillstep", "http://listen.di.fm/public1/chillstep.pls", "Chillout with a Dubstep influence") );
categories["Progressive"]=new Array ( 
        new Station( "Progressive", "http://listen.di.fm/public1/progressive.pls", "Forward thinking house, trance and techno for your mind") );
categories["House"]=new Array ( 
        new Station( "House", "http://listen.di.fm/public1/house.pls", "Silky sexy deep house music direct from New York city!") );
categories["Mainstage"]=new Array ( 
        new Station( "Mainstage", "http://listen.di.fm/public1/mainstage.pls", "The biggest DJs from the best festivals around the world!") );
categories["Minimal"]=new Array ( 
        new Station( "Minimal", "http://listen.di.fm/public1/minimal.pls", "Finest selection of Minimal Techno & House!!") );
categories["Hard Dance"]=new Array ( 
        new Station( "Hard Dance", "http://listen.di.fm/public1/harddance.pls", "Enjoy the harder side of throbbing house and trance. ") );
categories["EuroDance"]=new Array ( 
        new Station( "EuroDance", "http://listen.di.fm/public1/eurodance.pls", "The newest and best of Eurodance hits") );
categories["Vocal Lounge"]=new Array ( 
        new Station( "Vocal Lounge", "http://listen.di.fm/public1/vocallounge.pls", "Relaxing Vocals and Lounge Grooves") );
categories["UMF Radio"]=new Array ( 
        new Station( "UMF Radio", "http://listen.di.fm/public1/umfradio.pls", "UMF Radio 24/7") );
categories["Tech House"]=new Array ( 
        new Station( "Tech House", "http://listen.di.fm/public1/techhouse.pls", "A fusion of techno and house with a deep, soulful vibe.") );
categories["Electro House"]=new Array ( 
        new Station( "Electro House", "http://listen.di.fm/public1/electro.pls", "An eclectic mix of electro and dirty house") );
categories["Big Room House"]=new Array ( 
        new Station( "Big Room House", "http://listen.di.fm/public1/bigroomhouse.pls", "The most uplifting, floor-filling Big Room House!") );
categories["Trap"]=new Array ( 
        new Station( "Trap", "http://listen.di.fm/public1/trap.pls", "Electronic 808 beats with Hip Hop roots.") );
categories["PsyChill"]=new Array ( 
        new Station( "PsyChill", "http://listen.di.fm/public1/psychill.pls", "Downtempo psychedelic dub grooves, goa ambient, and world beats.") );
categories["Goa-Psy Trance"]=new Array ( 
        new Station( "Goa-Psy Trance", "http://listen.di.fm/public1/goapsy.pls", "A psychedelic voyage out of this world!") );
categories["Progressive Psy"]=new Array ( 
        new Station( "Progressive Psy", "http://listen.di.fm/public1/progressivepsy.pls", "Progress your mind to undiscovered psychedelic dimensions.") );
categories["Hardcore"]=new Array ( 
        new Station( "Hardcore", "http://listen.di.fm/public1/hardcore.pls", "DJ mixes, hard dance and NuNRG") );
categories["Downtempo Lounge"]=new Array ( 
        new Station( "Downtempo Lounge", "http://listen.di.fm/public1/downtempolounge.pls", "Relax with some Downtempo grooves.") );
categories["Moombahton"]=new Array ( 
        new Station( "Moombahton", "http://listen.di.fm/public1/moombahton.pls", "Hot House meets Dancehall Reggaeton") );
categories["DJ Mixes"]=new Array ( 
        new Station( "DJ Mixes", "http://listen.di.fm/public1/djmixes.pls", "Non-stop DJ sets featuring various forms of techno & trance!") );
categories["Russian Club Hits"]=new Array ( 
        new Station( "Russian Club Hits", "http://listen.di.fm/public1/russianclubhits.pls", "Russia's hottest club hits.") );
categories["Ambient"]=new Array ( 
        new Station( "Ambient", "http://listen.di.fm/public1/ambient.pls", "A blend of ambient, downtempo, and chillout") );
categories["Psybient"]=new Array ( 
        new Station( "Psybient", "http://listen.di.fm/public1/psybient.pls", "The Psychedelic side of Ambient") );
categories["Drum 'n Bass"]=new Array ( 
        new Station( "Drum 'n Bass", "http://listen.di.fm/public1/drumandbass.pls", "Representing the finest drum n' bass selection.") );
categories["EcLectronica"]=new Array ( 
        new Station( "EcLectronica", "http://listen.di.fm/public1/eclectronica.pls", "An eclectic mixture of modern electronica.") );
categories["Scouse House"]=new Array ( 
        new Station( "Scouse House", "http://listen.di.fm/public1/scousehouse.pls", "Bouncy and Pumping House Beats") );
categories["Oldschool Techno & Trance "]=new Array ( 
        new Station( "Oldschool Techno & Trance ", "http://listen.di.fm/public1/classictechno.pls", "Techno & trance from early to mid 90s!") );
categories["Epic Trance"]=new Array ( 
        new Station( "Epic Trance", "http://listen.di.fm/public1/epictrance.pls", "The best in uplifting and euphoric Trance") );
categories["UK Garage"]=new Array ( 
        new Station( "UK Garage", "http://listen.di.fm/public1/ukgarage.pls", "The latest and greatest in UK Garage!!") );
categories["Breaks"]=new Array ( 
        new Station( "Breaks", "http://listen.di.fm/public1/breaks.pls", "A fine assortment of trance and house breaks") );
categories["Gabber"]=new Array ( 
        new Station( "Gabber", "http://listen.di.fm/public1/gabber.pls", "Banging to the hardest sounds of gabber!") );
categories["Cosmic Downtempo"]=new Array ( 
        new Station( "Cosmic Downtempo", "http://listen.di.fm/public1/cosmicdowntempo.pls", "A downtempo journey into the cosmos") );
categories["Hard Techno"]=new Array ( 
        new Station( "Hard Techno", "http://listen.di.fm/public1/hardtechno.pls", "Heavy hitting Hard Techno & Schranz!") );
categories["Techno"]=new Array ( 
        new Station( "Techno", "http://listen.di.fm/public1/techno.pls", "Pure techno grooves!") );
categories["Electronic Pioneers"]=new Array ( 
        new Station( "Electronic Pioneers", "http://listen.di.fm/public1/electronicpioneers.pls", "Rediscover the earliest sounds of Electronica") );
categories["Soulful House"]=new Array ( 
        new Station( "Soulful House", "http://listen.di.fm/public1/soulfulhouse.pls", "House music selected from Paris with love!") );
categories["Deep House"]=new Array ( 
        new Station( "Deep House", "http://listen.di.fm/public1/deephouse.pls", "Only the sexiest, silky smooth and groovy Deep House.") );
categories["Deep Tech"]=new Array ( 
        new Station( "Deep Tech", "http://listen.di.fm/public1/deeptech.pls", "Deeper shades of house and techno with dub and blues influences.") );
categories["Tribal House"]=new Array ( 
        new Station( "Tribal House", "http://listen.di.fm/public1/tribalhouse.pls", "Finest selection of tribal and tech house!!") );
categories["Funky House"]=new Array ( 
        new Station( "Funky House", "http://listen.di.fm/public1/funkyhouse.pls", "A fine selection of funky house music!!") );
categories["Deep Nu-Disco"]=new Array ( 
        new Station( "Deep Nu-Disco", "http://listen.di.fm/public1/deepnudisco.pls", "Slo-mo house with ear perking space disco and low-slung bass beats!") );
categories["Underground Techno"]=new Array ( 
        new Station( "Underground Techno", "http://listen.di.fm/public1/undergroundtechno.pls", "Alternative Techno sounds") );
categories["Space Dreams"]=new Array ( 
        new Station( "Space Dreams", "http://listen.di.fm/public1/spacemusic.pls", "Ambient space music for expanding minds") );
categories["Hardstyle"]=new Array ( 
        new Station( "Hardstyle", "http://listen.di.fm/public1/hardstyle.pls", "Banging Hardstyle for your ears!!!") );
categories["Chillout Dreams"]=new Array ( 
        new Station( "Chillout Dreams", "http://listen.di.fm/public1/chilloutdreams.pls", "Relax to the sounds of dream and Ibiza style chillout") );
categories["Liquid DnB"]=new Array ( 
        new Station( "Liquid DnB", "http://listen.di.fm/public1/liquiddnb.pls", "Flowing with the freshest Liquid DnB!!") );
categories["Dark DnB"]=new Array ( 
        new Station( "Dark DnB", "http://listen.di.fm/public1/darkdnb.pls", "A twisted blend of heavy hitting Dark Drum and Bass!") );
categories["Classic EuroDance"]=new Array ( 
        new Station( "Classic EuroDance", "http://listen.di.fm/public1/classiceurodance.pls", "The finest imported cheese on the net!") );
categories["Hands Up"]=new Array ( 
        new Station( "Hands Up", "http://listen.di.fm/public1/handsup.pls", "Hands Up beats blending harder dance, trance and happy hardcore") );
categories["Club Sounds"]=new Array ( 
        new Station( "Club Sounds", "http://listen.di.fm/public1/club.pls", "The hottest club and dance tunes 24/7") );
categories["Classic Trance"]=new Array ( 
        new Station( "Classic Trance", "http://listen.di.fm/public1/classictrance.pls", "Relive the classic trance hits!!") );
categories["Classic Vocal Trance"]=new Array ( 
        new Station( "Classic Vocal Trance", "http://listen.di.fm/public1/classicvocaltrance.pls", "Classic sounds of Vocal Trance") );
categories["Club Dubstep"]=new Array ( 
        new Station( "Club Dubstep", "http://listen.di.fm/public1/clubdubstep.pls", "Bass fuelled, club shaking Dubstep.") );
categories["Dubstep"]=new Array ( 
        new Station( "Dubstep", "http://listen.di.fm/public1/dubstep.pls", "Dubstep hits and mixes!!!!") );
categories["Liquid Dubstep"]=new Array ( 
        new Station( "Liquid Dubstep", "http://listen.di.fm/public1/liquiddubstep.pls", "Mellow out to the rolling, soothing deep bass of Liquid Dubstep.") );
categories["Glitch Hop"]=new Array ( 
        new Station( "Glitch Hop", "http://listen.di.fm/public1/glitchhop.pls", "Bit-crushing, dub-infused Hip Hop sounds!") );
categories["Electropop"]=new Array ( 
        new Station( "Electropop", "http://listen.di.fm/public1/electropop.pls", "Catchy Pop fused with Electro Synth") );
categories["Disco House"]=new Array ( 
        new Station( "Disco House", "http://listen.di.fm/public1/discohouse.pls", "The grooviest Disco House tunes on the web.") );
categories["Classic EuroDisco"]=new Array ( 
        new Station( "Classic EuroDisco", "http://listen.di.fm/public1/classiceurodisco.pls", "Relive the sounds of Euro & Italo Disco.") );
categories["Future Synthpop"]=new Array ( 
        new Station( "Future Synthpop", "http://listen.di.fm/public1/futuresynthpop.pls", "Finest selection of futurepop and synthpop!!") );
categories["Latin House"]=new Array ( 
        new Station( "Latin House", "http://listen.di.fm/public1/latinhouse.pls", "Finest selection of Latin house!!") );
categories["Oldschool Acid"]=new Array ( 
        new Station( "Oldschool Acid", "http://listen.di.fm/public1/oldschoolacid.pls", "Oldschool sounds of Acid Techno, House, and Trance!") );
categories["Chiptunes"]=new Array ( 
        new Station( "Chiptunes", "http://listen.di.fm/public1/chiptunes.pls", "Playing the best chiptunes and video game music.") );
categories["Sankeys Radio"]=new Array ( 
        new Station( "Sankeys Radio", "http://listen.di.fm/public1/sankeys.pls", "The sound of Sankeys Worldwide.") );



images = new Object;
images["Bass & Jackin' House"]="bassnjackinhouse.jpg";
images["Future Garage"]="futuregarage.jpg";
images["Jungle"]="jungle.jpg";
images["Nightcore"]="nightcore.jpg";
images["Nu Disco"]="nudisco.jpg";
images["Bassline"]="bassline.jpg";
images["Oldschool House"]="oldschoolhouse.jpg";
images["Oldschool Rave"]="oldschoolrave.jpg";
images["Trance"]="trance.jpg";
images["Vocal Trance"]="vocaltrance.jpg";
images["Lounge"]="lounge.jpg";
images["Chillout"]="chillout.jpg";
images["Vocal Chillout"]="vocalchillout.jpg";
images["ChillHop"]="chillhop.jpg";
images["Chillstep"]="chillstep.jpg";
images["Progressive"]="progressive.jpg";
images["House"]="house.jpg";
images["Mainstage"]="mainstage.jpg";
images["Minimal"]="minimal.jpg";
images["Hard Dance"]="harddance.jpg";
images["EuroDance"]="eurodance.jpg";
images["Vocal Lounge"]="vocallounge.jpg";
images["UMF Radio"]="umfradio.jpg";
images["Tech House"]="techhouse.jpg";
images["Electro House"]="electro.jpg";
images["Big Room House"]="bigroomhouse.jpg";
images["Trap"]="trap.jpg";
images["PsyChill"]="psychill.jpg";
images["Goa-Psy Trance"]="goapsy.jpg";
images["Progressive Psy"]="progressivepsy.jpg";
images["Hardcore"]="hardcore.jpg";
images["Downtempo Lounge"]="downtempolounge.jpg";
images["Moombahton"]="moombahton.jpg";
images["DJ Mixes"]="djmixes.jpg";
images["Russian Club Hits"]="russianclubhits.jpg";
images["Ambient"]="ambient.jpg";
images["Psybient"]="psybient.jpg";
images["Drum 'n Bass"]="drumandbass.jpg";
images["EcLectronica"]="eclectronica.jpg";
images["Scouse House"]="scousehouse.jpg";
images["Oldschool Techno & Trance "]="classictechno.jpg";
images["Epic Trance"]="epictrance.jpg";
images["UK Garage"]="ukgarage.jpg";
images["Breaks"]="breaks.jpg";
images["Gabber"]="gabber.jpg";
images["Cosmic Downtempo"]="cosmicdowntempo.jpg";
images["Hard Techno"]="hardtechno.jpg";
images["Techno"]="techno.jpg";
images["Electronic Pioneers"]="electronicpioneers.jpg";
images["Soulful House"]="soulfulhouse.jpg";
images["Deep House"]="deephouse.jpg";
images["Deep Tech"]="deeptech.jpg";
images["Tribal House"]="tribalhouse.jpg";
images["Funky House"]="funkyhouse.jpg";
images["Deep Nu-Disco"]="deepnudisco.jpg";
images["Underground Techno"]="undergroundtechno.jpg";
images["Space Dreams"]="spacemusic.jpg";
images["Hardstyle"]="hardstyle.jpg";
images["Chillout Dreams"]="chilloutdreams.jpg";
images["Liquid DnB"]="liquiddnb.jpg";
images["Dark DnB"]="darkdnb.jpg";
images["Classic EuroDance"]="classiceurodance.jpg";
images["Hands Up"]="handsup.jpg";
images["Club Sounds"]="club.jpg";
images["Classic Trance"]="classictrance.jpg";
images["Classic Vocal Trance"]="classicvocaltrance.jpg";
images["Club Dubstep"]="clubdubstep.jpg";
images["Dubstep"]="dubstep.jpg";
images["Liquid Dubstep"]="liquiddubstep.jpg";
images["Glitch Hop"]="glitchhop.jpg";
images["Electropop"]="electropop.jpg";
images["Disco House"]="discohouse.jpg";
images["Classic EuroDisco"]="classiceurodisco.jpg";
images["Future Synthpop"]="futuresynthpop.jpg";
images["Latin House"]="latinhouse.jpg";
images["Oldschool Acid"]="oldschoolacid.jpg";
images["Chiptunes"]="chiptunes.jpg";
images["Sankeys Radio"]="sankeys.jpg";


function DIfmRadios()
{
    // last argument is the filter box
    ScriptableServiceScript.call( this, "Digitally Imported", 2, "Addictive electronic music", "Digitally Imported streams the world's most addictive electronic music. Our radio channels feature world renowned artists, DJs, and the hottest exclusive shows. Discover the community and the wide variety of electronic music covering Trance, House, Dance, Techno, Chillout, Breaks, Downtempo and so much more.", true );
    Amarok.debug( "ok." );
}

function onConfigure()
{
    Amarok.alert( "This script doesn't require configuration." );
}

function onPopulating( level, callbackData, filter )
{
	filter = filter.toLowerCase().replace("%20","");
	
    if ( level == 1 ) 
    {
        for( att in categories )
        {
	  			if(filter.length > 0)
			{
				var hasItems = false;
				var stationArray = categories[att];
				for ( i = 0; i < stationArray.length; i++ )
				{
					if(stationArray[i].name.toLowerCase().indexOf(filter) != -1)
					{
						hasItems = true;
						break;
					}
				}
				if(!hasItems) continue;
			}
			
            var cover = Amarok.Info.scriptPath() + "/" + images[att];
            Amarok.debug ("att: " + att + ", " + categories[att].name);
      
            item = Amarok.StreamItem;
	    item.level = 1;
	    item.callbackData = att;
	    item.itemName = att;
	    item.playableUrl = "";
	    item.infoHtml = "";
            item.coverUrl = cover;
	    script.insertItem( item );

        }
        script.donePopulating();

    }
    else if ( level == 0 ) 
    {
        Amarok.debug( " Compiling stations..." );
	//add the station streams as leaf nodes

        var stationArray = categories[callbackData];

	for ( i = 0; i < stationArray.length; i++ )
	{
                var cover = Amarok.Info.scriptPath() + "/" + images[callbackData];
		item = Amarok.StreamItem;
		item.level = 0;
		item.callbackData = "";
		item.itemName = stationArray[i].name;
		item.playableUrl = stationArray[i].url;
		item.album = callbackData;
		item.infoHtml = stationArray[i].description;
                item.artist = "Radio Stream";
                item.coverUrl = cover;
		script.insertItem( item );
	}
	script.donePopulating();
    }
}

function onCustomize() {
    var currentDir = Amarok.Info.scriptPath() + "/";
    var iconPixmap = new QPixmap(currentDir+"icon.png");
    script.setIcon(iconPixmap);
}

Amarok.configured.connect( onConfigure );

script = new DIfmRadios();
script.populate.connect( onPopulating );
script.customize.connect( onCustomize );
